{ MoveSC2VX - An OLE plugin for JED versions 8.5 and higher.
  This moves the sector of a multiselected vertex to the current vertex.
  Written by Craig Urquhart (UGG_BOOT) 9Dec98. Email: cu@rpi.net.au
  Imperial Detention Center: http://www.rpi.net.au/~cu/main.html }

program MoveSC2VX;

{ You need 'ComObj' for the OLE connection, and 'Windows' for the message box.
  If you used the Delphi ShowMessage box you would need 'Dialogs' which would
  add another 100K to your executable filesize for almost no advantage }
uses
    SysUtils, ComObj, Windows;

var
   Jed: Variant;

{ Check that Jed is running and that it's version supports the functions used }
procedure StartUp;
begin
     try
        Jed := CreateOleObject('JED.App');
     except
           MessageBox(0, PChar('START JED (v8.5+) BEFORE USE.'),
                     PChar('Cleave2VX'), MB_ICONEXCLAMATION);
           Halt(1);
     end;
     if Jed.Version < 0.85 then
     begin
          MessageBox(0, PChar('REQUIRES JED VERSION 8.5 OR HIGHER.'),
                     PChar('Cleave2VX'), MB_ICONEXCLAMATION);
          Halt(1);
     end;
end;

procedure MoveToVertex;
var
   XS, YS, ZS, XM, YM, ZM, XDIF, YDIF, ZDIF: Double;
   SCS, VXS, SCM, VXM, i: Integer;
   SCSO, SCMO: Variant;
begin
{ Check that al least one vertex is multiselected  }
     Jed.MapMode := 2;
     if Jed.NMultiSelected(2) < 1 then
     begin
          MessageBox(0, PChar('MULTISELECT THE VERTEX ON THE SECTOR TO MOVE'),
                     PChar('MoveSC2VX'), MB_ICONEXCLAMATION);
          Halt(1);
     end;

{ Setup a variant for the each vertex and get the XYZ distances between them }
     SCS := Jed.CurSC;
     VXS := Jed.CurVX;
     SCSO := Jed.Level.GetSector(SCS);
     SCSO.GetVertex(VXS, XS, YS, ZS);
     Jed.GetSelectedVX(0, SCM, VXM);
     SCMO := Jed.Level.GetSector(SCM);
     SCMO.GetVertex(VXM, XM, YM, ZM);
     XDIF := XS - XM;
     YDIF := YS - YM;
     ZDIF := ZS - ZM;

{ Move the sector vertices to their new coordinates }
     for i := 0 to (SCMO.NVertices - 1) do
     begin
          SCMO.GetVertex(i, XM, YM, ZM);
          SCMO.SetVertex(i, XM + XDIF, YM + YDIF, ZM + ZDIF);
     end;

{ Update move sector and redraw display }
     SCMO.Update;
     Jed.UpdateMap;
end;

{ This is the 'main' program which is run first }
begin
     StartUp;             { Try to connect to JED through OLE, otherwise quit }
     MoveToVertex;        { Moves sector to current vertex }
end.









